$(document).ready(function(e) {
    $("#form_id").submit(function (e){
        var ticket_type = $("#tck_type").val();
        if (ticket_type == "mantenimiento"){
            var req = required_maintenance()
            if(req['portal_contact_name'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Nombre");
            }
            if(req['portal_email'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Correo");
            }
            if(req['portal_phone'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Teléfono");
            }
            if(req['portal_main_type'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Tipo de mantenimiento");
            }
            if(req['portal_date_fail'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Fecha de Falla");
            }
            if(req['portal_severity'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Tipo de Gravedad");
            }
            if(req['portal_description'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Descripción");
            }
            if(req['portal_fail_type'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Tipo de Falla");
            }
            if(req['portal_file'] == 0){
                e.preventDefault();
                show_error("Es necesario agregar los archivos de evidencia|");
            }
            
        }
        if (ticket_type == "emergencia_mantenimiento"){
            var req = required_maintenance()
            if(req['portal_contact_name'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Nombre");
            }
            if(req['portal_email'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Correo");
            }
            if(req['portal_phone'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Teléfono");
            }
           
            if(req['portal_date_fail'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Fecha de Falla");
            }
           
            if(req['portal_description'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Descripción");
            }
            if(req['portal_fail_type'] == ""){
                e.preventDefault();
                show_error("Es necesario llenar el campo de Tipo de Falla");
            }
            if(req['portal_file'] == 0){
                e.preventDefault();
                show_error("Es necesario agregar los archivos de evidencia|");
            }
            
        }

    });

    function required_maintenance(){
        return {
            'partner_id': $("#partner_id").val(),
            'portal_contact_name': $("#portal_contact_name").val(),
            'portal_email': $("#portal_email").val(),
            'portal_phone': $("#portal_phone").val(),
            'portal_main_type': $("#portal_main_type").val(),
            'portal_date_fail':$("#portal_date_fail").val(),
            'portal_severity': $("#portal_severity").val(),
            'portal_description': $("#portal_description").val(),
            'portal_fail_type': $("#portal_fail_type").val(),
            'portal_file':  document.getElementById('portal_file').files.length
        }
    }

    function required_maintenance_emergency(){
        return {
            'partner_id': $("#partner_id").val(),
            'portal_contact_name': $("#portal_contact_name").val(),
            'portal_email': $("#portal_email").val(),
            'portal_phone': $("#portal_phone").val(),
            'portal_date_fail': $("#portal_date_fail").val(),
            'portal_description': $("#portal_description").val(),
            'portal_fail_type': $("#portal_fail_type").val(),
            'portal_file':  document.getElementById('portal_file').files.length
        }
    }

    function show_error(message){
        return swal({
            title:"Error",
            text: message,
            icon: "error",
            buttons: "Ok",
        })
    }



    $(document).on("change", "#portal_date_fail", function (e) {
        let dateformat = /^(0?[1-9]|[1-2][0-9]|3[01])[\/](0?[1-9]|1[0-2])/;
        var date = $("#portal_date_fail").val();
        if (date.match(dateformat)){
            var response = validate_Date(date)
            console.log(response)
            if (response == ""){
                $("#portal_date_fail").val("");
                show_error("Favor de ingresar el formato de fecha valido");
            }
        }else{
            console.log('formato aún no valido')
        }
    });

    function validate_Date(date){
        let ListofDays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
        dt = date.split("/");
        day = parseInt(dt[0]);
        month = parseInt(dt[1]);
        year = parseInt(dt[2]);
        if (month > 0 && month <=  ListofDays.length && Number.isInteger(year)){
            if( day > 0 && day <= ListofDays[month-1]){
                return date
            }else{
                return "";
            }
        }else{
            return "";
        }
    }
});